#include <errno.h>
#include <stdio.h>
#include <string>
#include <unistd.h>

	// 어날라이져에도 포함시킨다.
#include "../../include/AnalysisModuleInterface.h"
#include "../../include/InOutPin.h"

#define PIN_NAME_PARSING_RESULT		"ParsingResultPin"

#define IOP_PARSING_RESULT		IOP_USER + 1


#include "PStringToken.h"		// 이건 복사해서 내 것과 같은 폴더에 넣어야한다.

#include "LSMIncorrectCalculationInfo.h"
//#include "LSMIncorrectCalculation.h"

#define LINUX



#include "LICAnalyzer.h"
#include "LVarContainer.h"
#include "LVariableItem.h"
								// extern "C" 라고 된것 외에는 다 지워도 되는 함수

extern "C" bool GetModuleInfo( CAnalysisModuleInfo* pInfo )	// 이건 건들필요가 없는 함수
{ 
	// printf( "In UNOLexer GetModuleInfo\n" );
	pInfo->m_uiId = MODULE_ID;
	memcpy( pInfo->m_szName , MODULE_NAME , strlen( MODULE_NAME ) );
	pInfo->m_uiRevisionNo = (unsigned int)MODULE_REVISION_NO; 

	pInfo->m_uiInputId = IOP_SOURCE_FILES;
	memcpy( pInfo->m_szInputName , PIN_NAME_SOURCE_FILE , strlen( PIN_NAME_SOURCE_FILE ) );
	// pInfo->m_szInputDescription  

	pInfo->m_uiOutputId = IOP_PARSING_RESULT;
	memcpy( pInfo->m_szOutputName , PIN_NAME_PARSING_RESULT , strlen( PIN_NAME_PARSING_RESULT ) );
	// pInfo->m_szOutputDescription 

	return true;
}

extern "C" void	Initialize( CAnalysisNotifyInterface* pInterface , CModuleRelayInterface* pRelayInterface )
{
	// g_pInterface = pInterface;
	// g_pInterface->OnNotifyResult( 파일명, 라인수 , 에러명 );	// 모듈이 찾아낸 검증오류가 발견될때마다 OnNotifyResult를 호출하면 된다.
	//#include "../../include/AnalysisModuleInterface.h" 여기에 보면있다.

	// g_pInterface->OnNotifyError( ... );	// 모듈이 찾아낸 검증오류가 발견될때마다 OnNotifyResult를 호출하면 된다. #include "../../include/AnalysisModuleInterface.h"
	// g_pInterface->OnNotifyProcess( ... );
	LICAnalyzer::SetNotifyInterface( pInterface );
}

extern "C" bool StartProcess( CInOutPinBase* pInputPin )
{	
	CSourceFilePin* pSourceFilePin = ( CSourceFilePin*  )pInputPin;
	
	int nSourceFileCount	= pSourceFilePin->m_nFileCount;
	int nCount		= 0;
	LICAnalyzer analyzer;
	analyzer.SetStopValue( false );
	
	PStringToken StringToken;
	StringToken.CreateTokenBuf( pSourceFilePin->m_pszFileName , strlen( pSourceFilePin->m_pszFileName )  );

	char* pTokenData = StringToken.GetFirstToken( SOURCE_FILENAME_SEPERATOR );
	while( NULL != pTokenData && nCount < nSourceFileCount )
	{
		pTokenData = StringToken.GetNextToken( SOURCE_FILENAME_SEPERATOR );
		analyzer.AnalyzeFile( pTokenData );
		nCount++;
	}
	StringToken.DeleteTokenBuf();

	LICAnalyzer::SetStopValue( true );

	return 0;
}

extern "C" bool StopProcess()
{
	LICAnalyzer::SetStopValue( true );
	return true;
}

